using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.Ink;

namespace UW
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private InkOverlay inkOverlay;
		private RecognizerContext rc;
		private System.Windows.Forms.TextBox textBox1;
		private Strokes strokesToReco;
		private System.Windows.Forms.ListBox listBox1;
		private RecognitionResult result;
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			inkOverlay = new InkOverlay(Handle);
			inkOverlay.Enabled = true;

			inkOverlay.Stroke +=new InkCollectorStrokeEventHandler(inkOverlay_Stroke);
			inkOverlay.DefaultDrawingAttributes.Color = Color.Blue;
		
			rc = new RecognizerContext();
			strokesToReco = inkOverlay.Ink.CreateStrokes();
			rc.Strokes = strokesToReco;

			rc.RecognitionWithAlternates +=new RecognizerContextRecognitionWithAlternatesEventHandler(rc_RecognitionWithAlternates);
			textBox1.MouseUp +=new MouseEventHandler(textBox1_MouseUp);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 26.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(0, 0);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(616, 47);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(8, 336);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(448, 95);
			this.listBox1.TabIndex = 1;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 478);
			this.Controls.Add(this.listBox1);
			this.Controls.Add(this.textBox1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void inkOverlay_Stroke(object sender, InkCollectorStrokeEventArgs e)
		{
			this.Text = inkOverlay.Ink.Strokes.Count.ToString();

			//e.Stroke.DrawingAttributes.Width = 100 * inkOverlay.Ink.Strokes.Count;
			//this.Refresh();
			strokesToReco.Add(e.Stroke);
			rc.BackgroundRecognizeWithAlternates();
		}

		private void rc_RecognitionWithAlternates(object sender, RecognizerContextRecognitionWithAlternatesEventArgs e)
		{
			textBox1.Text = e.Result.TopString;
			result = e.Result;
		}

		private void textBox1_MouseUp(object sender, MouseEventArgs e)
		{
			int selStart = textBox1.SelectionStart;
			int selLen = textBox1.SelectionLength;

			RecognitionAlternates ras = result.GetAlternatesFromSelection(selStart, selLen);
			inkOverlay.Selection = ras.Strokes;

			listBox1.Items.Clear();
			foreach (RecognitionAlternate ra in ras) 
			{
				listBox1.Items.Add(ra);
			}
		}
	}
}
